/*================================================================================================================*/
// ********************************** THESE ARE THE INFORMATIONS OF THE MAP: ************************************ //
/*================================================================================================================*/
// CREATED BY DANY:
// A RANDOM MAP FOR AOE3:
// DECEMBER 2006:
/*================================================================================================================*/
// ********************************* MAIN ENTRY POINT FOR RANDOM MAP SCRIPT: ************************************ //
/*================================================================================================================*/
include "mercenaries.xs";
void main(void)
{
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.01);
/*================================================================================================================*/
// **************************************** CHOOSE THE NATIVES TRIBES: ****************************************** //
/*================================================================================================================*/
        int subCiv0=-1;
        int subCiv1=-1;

        if (rmAllocateSubCivs(2) == true)
	  
   {
		subCiv0=rmGetCivID("Aztecs");
        if (subCiv0 >= 0)
        rmSetSubCiv(0, "Aztecs");
		
		subCiv1=rmGetCivID("Incas");
        if (subCiv1 >= 0)
        rmSetSubCiv(1, "Incas");
   }
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.05);
/*================================================================================================================*/
// ******************************************* DEFINE THE MAP SIZE: ********************************************* //
/*================================================================================================================*/
      // Picks the map size
      int playerTiles = 15500;
      
	  if (cNumberNonGaiaPlayers >4)
          playerTiles = 14000;
      if (cNumberNonGaiaPlayers >6)
          playerTiles = 13000;
		
	  int size=2.0*sqrt(cNumberNonGaiaPlayers*playerTiles);
	  rmEchoInfo("Map size="+size+"m x "+size+"m");
	  rmSetMapSize(size, size);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.10);
/*================================================================================================================*/
// **************************************** DEFINE THE MAP PARAMETERS: ****************************************** // 
/*================================================================================================================*/
	  // SET THE MAP ELEVATION PARAMETERS:
	  rmSetMapElevationParameters(cElevTurbulence, 0.4, 6, 0.5, 3.0);  // DAL - original
	  rmSetMapElevationHeightBlend(1); // FROM PAMPAS:

	  // PICKS A DEFAULT WATER HEIGHT:
	  rmSetSeaLevel(1.0); // FROM PATAGONIA:

      // PICKS DEFAULT TERRAIN AND WATER:
	  rmSetSeaType("new england coast"); // FROM PATAGONIA:
	  rmEnableLocalWater(false); // FROM PATAGONIA:
	    
	  // SET BASE TERRAIN MIX:
	  rmSetBaseTerrainMix("patagonia_grass"); // FROM PATAGONIA:
	  
	  // TERRAIN INITIALIZE:
	  rmTerrainInitialize("patagonia\ground_dirt1_pat", 10.0); // FROM PATAGONIA:	 
	  	  
	  // SET MAP TYPE:
	  rmSetMapType("patagonia"); // FROM PATAGONIA:
	  rmSetMapType("water"); // FROM PATAGONIA:
	  rmSetMapType("grass"); // FROM PATAGONIA:
	  	  
	  // SET LIGHTING:
	  rmSetLightingSet("patagonia"); // FROM PATAGONIA:
	  
	  // CHOOSE MERCS:
	  chooseMercs();

	  // CORNER CONSTRAINT:
	  rmSetWorldCircleConstraint(false);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.15);
/*================================================================================================================*/
// ******************************************** DEFINE THE CLASSES: ********************************************* //
/*================================================================================================================*/
      int classPlayer=rmDefineClass("player");
	  rmDefineClass("classHill");
	  rmDefineClass("classPatch");
	  rmDefineClass("starting settlement");
	  rmDefineClass("startingUnit");
	  rmDefineClass("classForest");
	  rmDefineClass("importantItem");
	  rmDefineClass("natives");
	  rmDefineClass("classCliff");
	  rmDefineClass("nuggets");
	  rmDefineClass("center");
	  int canyon=rmDefineClass("canyon");
      int connectionClass=rmDefineClass("connection");
	  int teamClass=rmDefineClass("teamClass"); 	  
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.20);
/*================================================================================================================*/
// ***************************************** DEFINE THE CONSTRAINTS: ******************************************** //
/*================================================================================================================*/
  	  // MAP EDGE CONSTRAINTS:
	  int playerEdgeConstraint=rmCreateBoxConstraint("player edge of map", rmXTilesToFraction(6), rmZTilesToFraction(6), 1.0-rmXTilesToFraction(6), 1.0-rmZTilesToFraction(6), 0.01);
      int edgeConstraint=rmCreateBoxConstraint("avoid edge of map", rmXTilesToFraction(15), rmZTilesToFraction(15), 1.0-rmXTilesToFraction(15), 1.0-rmZTilesToFraction(15), 0.01);
	  
	  // PLAYER CONSTRAINTS:
	  int longPlayerConstraint=rmCreateClassDistanceConstraint("long stay away from players", classPlayer, 60.0);
	  int playerConstraint=rmCreateClassDistanceConstraint("stay away from players", classPlayer, 25.0);
	  int mediumPlayerConstraint=rmCreateClassDistanceConstraint("medium stay away from players", classPlayer, 20.0);
	  int shortPlayerConstraint=rmCreateClassDistanceConstraint("stay away from players short", classPlayer, 8.0);
	 
      // CARDINAL DIRECTIONS: - "HALVES" OF THE MAP:
      int Northward=rmCreatePieConstraint("northMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(265), rmDegreesToRadians(95));
      int Southward=rmCreatePieConstraint("southMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(85), rmDegreesToRadians(275));
      int Eastward=rmCreatePieConstraint("eastMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(355), rmDegreesToRadians(185));
      int Westward=rmCreatePieConstraint("westMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(175), rmDegreesToRadians(5));

      // RESOURCES AVOIDANCE:
	  int avoidResource=rmCreateTypeDistanceConstraint("resource avoid resource", "resource", 10.0);
      int forestConstraint=rmCreateClassDistanceConstraint("forest vs. forest", rmClassID("classForest"), 50.0);
	  int shortForestConstraint=rmCreateClassDistanceConstraint("short forest vs. forest", rmClassID("classForest"), 10.0);
	  
	  // VULTURES AVOIDANCE:
	  int avoidVultures=rmCreateTypeDistanceConstraint("avoids Vultures", "PropVulturePerching", 40.0);
	  
	  // CANYON AVOIDANCE:
	  int canyonConstraint=rmCreateClassDistanceConstraint("canyons start away from each other", canyon, 5.0);
	  int avoidCanyons=rmCreateClassDistanceConstraint("avoid canyons", rmClassID("canyon"), 35.0);
	  int shortAvoidCanyons=rmCreateClassDistanceConstraint("short avoid canyons", rmClassID("canyon"), 15.0);
	  
	  // NATIVES AVOIDANCE:
	  int avoidNatives=rmCreateClassDistanceConstraint("avoid natives", rmClassID("natives"), 15.0);
	  
	  // SILVER AVOIDANCE:
	  //int avoidSilver=rmCreateTypeDistanceConstraint("gold avoid gold", "Mine", 45.0);
	  //int shortAvoidSilver=rmCreateTypeDistanceConstraint("short gold avoid gold", "Mine", 20.0);
	  
	  // COIN AVOIDANCE:
	  int avoidCoin=rmCreateTypeDistanceConstraint("avoid coin", "gold", 10.0);
      int shortAvoidSilver=rmCreateTypeDistanceConstraint("short gold avoid gold", "Mine", 20.0);
      int coinAvoidCoin=rmCreateTypeDistanceConstraint("coin avoids coin", "gold", 35.0);
  
	  
	  // IMPASSABLE LAND:
	  int avoidImpassableLand=rmCreateTerrainDistanceConstraint("avoid impassable land", "Land", false, 10.0);
	  int shortAvoidImpassableLand=rmCreateTerrainDistanceConstraint("short avoid impassable land", "Land", false, 4.0);
      int longAvoidImpassableLand=rmCreateTerrainDistanceConstraint("forests avoid impassable land", "land", false, 18.0);
	  int centerConstraintFar=rmCreateClassDistanceConstraint("stay away from center far", rmClassID("center"), rmXFractionToMeters(0.23));
	  int centerConstraint=rmCreateClassDistanceConstraint("stay away from center", rmClassID("center"), rmXFractionToMeters(0.10));
	  int keepToEdge=rmCreateClassDistanceConstraint("stay near edge of map", rmClassID("center"), rmXFractionToMeters(0.49));
	  
	  // DECORATION AVOIDANCE:
	  int avoidAll=rmCreateTypeDistanceConstraint("avoid all", "all", 6.0);
	  
	  // FRUITS AVOIDANCE:
	  int avoidFruits=rmCreateTypeDistanceConstraint("stuffs avoids berries", "berrybush", 12.0);
	  int fruitsAvoidFruits=rmCreateTypeDistanceConstraint("berries avoids berries", "berrybush", 30.0);
	  
	  
	  // WATER AVOIDANCE:
	  int avoidWater = rmCreateTerrainDistanceConstraint("avoid water", "Land", false, 10.0);
	  
      // NATURE AVOIDANCE:
	  int avoidBuzzards=rmCreateTypeDistanceConstraint("buzzard avoid buzzard", "BuzzardFlock", 70.0);
	  int avoidBison=rmCreateTypeDistanceConstraint("avoid Bison", "Bison", 20);
	  int avoidPronghorn=rmCreateTypeDistanceConstraint("avoid Pronghorn", "pronghorn", 15.0);
	  int pronghornAvoidPronghorn=rmCreateTypeDistanceConstraint("Pronghorn avoids Pronghorn", "pronghorn", 45.0);
	  int avoidCow=rmCreateTypeDistanceConstraint("cow avoids cow", "cow", 50.0);
	  int avoidBighorn=rmCreateTypeDistanceConstraint("avoid bighorn", "bighornsheep", 35.0);
	  int avoidSheep=rmCreateTypeDistanceConstraint("sheep avoids sheep", "sheep", 40.0);
   
	  
	  // TRADE ROUTE AVOIDANCE:
	  int avoidTradeRoute=rmCreateTradeRouteDistanceConstraint("trade route", 5.0);
	  int avoidTradeRouteSockets=rmCreateTypeDistanceConstraint("avoid Trade Socket", "sockettraderoute", 10);
	  
	  // NUGGET AVOIDANCE:
	  int avoidNugget=rmCreateClassDistanceConstraint("stuff avoid nugget", rmClassID("nuggets"), 20.0);
	  int avoidNuggetLong=rmCreateClassDistanceConstraint("nugget vs. nugget longer", rmClassID("nuggets"), 80.0);
	  int shortAvoidNugget=rmCreateClassDistanceConstraint("nugget vs. nugget short", rmClassID("nuggets"), 8.0);
	  int nuggetAvoidNugget=rmCreateClassDistanceConstraint("nugget vs. nugget long", rmClassID("nuggets"), 40.0);
	  
	  // STARTING UNITS AVOIDANCE: 
	  int avoidStartingUnits=rmCreateClassDistanceConstraint("objects avoid starting units", rmClassID("startingUnit"), 8.0);
      
	  // IMPORTANT ITEM AVOIDANCE:
	  int avoidImportantItem=rmCreateClassDistanceConstraint("things avoid each other", rmClassID("importantItem"), 10.0);
	  
	  // PATCH AVOIDANCE:
	  int patchConstraint=rmCreateClassDistanceConstraint("patch vs. patch", rmClassID("classPatch"), 5.0);
      
	  // CONNECTION CONSTRAINT:
	  int connectionConstraint=rmCreateClassDistanceConstraint("stay away from connection", connectionClass, 5.0);
      int connectionConstraintLong=rmCreateClassDistanceConstraint("stay farther away from connection", connectionClass, 25.0);
	  
	  // TEAM LANDS AVOIDANCE:
	  int avoidTeamLands=rmCreateClassDistanceConstraint("avoid team lands", rmClassID("teamClass"), 2.0);

	  // CIRCLE CONSTRAINT:
	  int circleConstraint=rmCreatePieConstraint("circle Constraint", 0.5, 0.5, 0, rmZFractionToMeters(0.47), rmDegreesToRadians(0), rmDegreesToRadians(360));
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.25);
/*================================================================================================================*/
// ************************************* DEFINE THE STARTING TCID AND UNITS: ************************************ //
/*================================================================================================================*/
	  int TCID = rmCreateObjectDef("player TC");
	  if (rmGetNomadStart())
	{
	  rmAddObjectDefItem(TCID, "CoveredWagon", 1, 0.0);
	}
	  else
	{
      rmAddObjectDefItem(TCID, "townCenter", 1, 0);
	}
	  rmSetObjectDefMinDistance(TCID, 0.0);
	  rmSetObjectDefMaxDistance(TCID, 10.0);
	  rmAddObjectDefConstraint(TCID, avoidTradeRoute);
	  rmAddObjectDefToClass(TCID, rmClassID("player"));
	  rmAddObjectDefToClass(TCID, rmClassID("startingUnit"));

	  int startingUnits = rmCreateStartingUnitsObjectDef(5.0);
	  rmSetObjectDefMinDistance(startingUnits, 8.0);
	  rmSetObjectDefMaxDistance(startingUnits, 12.0);
	  rmAddObjectDefToClass(startingUnits, rmClassID("startingUnit"));
	  rmAddObjectDefConstraint(startingUnits, avoidStartingUnits);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.30);
/*================================================================================================================*/
// ************************************** DEFINE THE STARTING RESOURCES: **************************************** //
/*================================================================================================================*/
	  int playerSilverID = rmCreateObjectDef("player silver");
	  rmAddObjectDefItem(playerSilverID, "mine", 1, 0);
	  rmAddObjectDefConstraint(playerSilverID, avoidTradeRoute);
	  rmSetObjectDefMinDistance(playerSilverID, 20.0);
	  rmSetObjectDefMaxDistance(playerSilverID, 26.0);
	  rmAddObjectDefToClass(playerSilverID, rmClassID("startingUnit"));
	  rmAddObjectDefConstraint(playerSilverID, avoidImpassableLand);
	  rmAddObjectDefConstraint(playerSilverID, avoidStartingUnits);

	  int playerSilver2ID = rmCreateObjectDef("player silver second");
	  rmAddObjectDefItem(playerSilver2ID, "mine", 1, 0);
	  rmAddObjectDefConstraint(playerSilver2ID, avoidTradeRoute);
	  rmSetObjectDefMinDistance(playerSilver2ID, 40.0);
	  rmSetObjectDefMaxDistance(playerSilver2ID, 50.0);
	  rmAddObjectDefToClass(playerSilver2ID, rmClassID("startingUnit"));
	  rmAddObjectDefConstraint(playerSilver2ID, avoidImpassableLand);
	  rmAddObjectDefConstraint(playerSilver2ID, avoidStartingUnits);
      //rmAddObjectDefConstraint(playerSilver2ID, shortAvoidSilver);
      rmAddObjectDefConstraint(playerSilver2ID, playerConstraint);

	  int playerSilver3ID = rmCreateObjectDef("player silver third");
	  rmAddObjectDefItem(playerSilver3ID, "mine", 1, 0);
	  rmAddObjectDefConstraint(playerSilver3ID, avoidTradeRoute);
	  rmSetObjectDefMinDistance(playerSilver3ID, 65.0);
	  rmSetObjectDefMaxDistance(playerSilver3ID, 80.0);
	  rmAddObjectDefToClass(playerSilver3ID, rmClassID("startingUnit"));
	  rmAddObjectDefConstraint(playerSilver3ID, avoidImpassableLand);
	  rmAddObjectDefConstraint(playerSilver3ID, avoidStartingUnits);
      rmAddObjectDefConstraint(playerSilver3ID, longPlayerConstraint);

	  int StartAreaTreeID=rmCreateObjectDef("starting trees");
	  rmAddObjectDefItem(StartAreaTreeID, "TreeSonora", rmRandInt(7,10), 5.0);
	  rmAddObjectDefItem(StartAreaTreeID, "UnderbrushDesert", rmRandInt(4,6), 4.0);
	  rmSetObjectDefMinDistance(StartAreaTreeID, 8);
	  rmSetObjectDefMaxDistance(StartAreaTreeID, 15);
	  rmAddObjectDefToClass(StartAreaTreeID, rmClassID("startingUnit"));
	  rmAddObjectDefConstraint(StartAreaTreeID, avoidImpassableLand);
	  rmAddObjectDefConstraint(StartAreaTreeID, avoidTradeRoute);
	  rmAddObjectDefConstraint(StartAreaTreeID, avoidResource);

      int berryNum = rmRandInt(2,5);
	  int StartBerriesID=rmCreateObjectDef("starting berries");
	  rmAddObjectDefItem(StartBerriesID, "berrybush", berryNum, 4.0);
	  rmSetObjectDefMinDistance(StartBerriesID, 10);
	  rmSetObjectDefMaxDistance(StartBerriesID, 15);
	  rmAddObjectDefToClass(StartBerriesID, rmClassID("startingUnit"));
	  rmAddObjectDefConstraint(StartBerriesID, avoidImpassableLand);
	  rmAddObjectDefConstraint(StartBerriesID, avoidStartingUnits);
	  rmAddObjectDefConstraint(StartBerriesID, avoidResource);

	  int pronghornNum = rmRandInt(6, 8);
	  int pronghornID=rmCreateObjectDef("pronghorn herd");
	  rmAddObjectDefItem(pronghornID, "pronghorn", pronghornNum, 6.0);
	  rmSetObjectDefCreateHerd(pronghornID, true);
	  rmSetObjectDefMinDistance(pronghornID, 14.0);
	  rmSetObjectDefMaxDistance(pronghornID, 20.0);
	  rmAddObjectDefToClass(pronghornID, rmClassID("startingUnit"));
	  rmAddObjectDefConstraint(pronghornID, avoidResource);
	  rmAddObjectDefConstraint(pronghornID, avoidImpassableLand);
      rmAddObjectDefConstraint(pronghornID, avoidNugget);
	  rmAddObjectDefConstraint(pronghornID, edgeConstraint);
      //rmPlaceObjectDefPerPlayer(pronghornID, false, 1);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.35);
/*================================================================================================================*/
// *********************************************** BUILD AREAS ************************************************** //
/*================================================================================================================*/
// *********************************** BUILD UP LAND MASS TO MAKE CLIFF EDGES: ********************************** //
/*================================================================================================================*/
      int bigContinentID=rmCreateArea("big continent");
      if (cNumberNonGaiaPlayers >3)
         //rmSetAreaSize(bigContinentID, 0.78, 0.78);
		 rmSetAreaSize(bigContinentID, 0.68, 0.68);
      else 
         //rmSetAreaSize(bigContinentID, 0.77, 0.77);
		 rmSetAreaSize(bigContinentID, 0.68, 0.68);
      rmSetAreaWarnFailure(bigContinentID, false);
      rmSetAreaSmoothDistance(bigContinentID, 10);
      rmSetAreaMix(bigContinentID, "patagonia_dirt");
      rmSetAreaCoherence(bigContinentID, 0.9);
      rmSetAreaLocation(bigContinentID, 0.5, 0.5);
	  rmSetAreaCliffType(bigContinentID, "Patagonia");
      rmSetAreaCliffEdge(bigContinentID, 1, 1.0, 0.0, 0.0, 0);
      rmSetAreaCliffHeight(bigContinentID, -8, 1.0, 0.3);
      rmSetAreaCliffPainting(bigContinentID, false, false, true);
      rmAddAreaToClass(bigContinentID, rmClassID("classCliff"));
      rmBuildArea(bigContinentID);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.40);
/*================================================================================================================*/
// ********************************** SET UP THE PLAYER STARTING LOCATIONS: ************************************* //
/*================================================================================================================*/
	    if ( cNumberTeams == 2 )
	{
		rmSetPlacementTeam(0);
		rmSetPlacementSection(0.15, 0.35);
		if (cNumberNonGaiaPlayers >6)
		{
			rmSetPlacementSection(0.13, 0.37);
		}
		// rmPlacePlayersCircular(0.35, 0.40, 0.0);
		   rmPlacePlayersCircular(0.36, 0.37, 0.0);


		rmSetPlacementTeam(1);
		rmSetPlacementSection(0.65, 0.85);
		if (cNumberNonGaiaPlayers >6)
		{
			rmSetPlacementSection(0.63, 0.87);
		}
		// rmPlacePlayersCircular(0.35, 0.40, 0.0);
		   rmPlacePlayersCircular(0.36, 0.37, 0.0);
	}
	else
	{
  		rmSetPlacementSection(0.0, 0.95);
		rmPlacePlayersCircular(0.40, 0.42, 0.0);
	}   
   
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.45);
/*================================================================================================================*/
// ********************************************** SET UP A RIVER: *********************************************** //
/*================================================================================================================*/
 // Define river width based on # of players
	int rivermin = -1;
	int rivermax = -1;

	if (cNumberNonGaiaPlayers <= 3)
	{
		//rivermin = 5;
		//rivermax = 6;
		rivermin = 7;
		rivermax = 8;
	}
	else
	{
		 rivermin = 6;
		 rivermax = 8;
	}
/*----------------------------------------------------------------------------------------------------------------*/   
      // int coloradoRiver1 = rmRiverCreate(-1, "Pampas River", 30, 10, rivermin, rivermax); // CROSSING RIVERS
      int coloradoRiver1 = rmRiverCreate(-1, "Amazon River", 30, 10, rivermin, rivermax); // CROSSING RIVERS
			  
	  // rmRiverSetConnections(coloradoRiver1, 0.0, 0.20, 1.0, 0.50);
	     rmRiverSetConnections(coloradoRiver1, 0.0, 1.0, 1.0, 0.0);
	
	  //rmRiverSetShallowRadius(coloradoRiver1, rmRandInt(10, 12));
	  //rmRiverAddShallow(coloradoRiver1, rmRandFloat(0.1, 0.35)); // Begin defining shallows in the river
	
	  rmRiverSetShallowRadius(coloradoRiver1, rmRandInt(10, 12));
	  rmRiverAddShallow(coloradoRiver1, 0.5);

	  //rmRiverSetShallowRadius(coloradoRiver1, rmRandInt(10, 12));
	  //rmRiverAddShallow(coloradoRiver1, rmRandFloat(0.65, 0.95));
	
	  rmRiverSetBankNoiseParams(coloradoRiver1, 0.07, 2, 1.5, 10.0, 0.667, 3.0);
	
	  rmRiverBuild(coloradoRiver1);
	  //rmRiverReveal(coloradoRiver1, 0);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.50);
/*================================================================================================================*/
// ***************************************** SET UP THE PLAYER AREAS: ******************************************* //
/*================================================================================================================*/
      float playerFraction=rmAreaTilesToFraction(100);
      for(i=1; <cNumberPlayers)
   {
      int id=rmCreateArea("Player"+i);
      rmSetPlayerArea(i, id);
      rmSetAreaSize(id, playerFraction, playerFraction);
      rmAddAreaToClass(id, classPlayer);
      rmSetAreaMinBlobs(id, 1);
      rmSetAreaMaxBlobs(id, 1);
      rmAddAreaConstraint(id, playerConstraint); 
      rmAddAreaConstraint(id, playerEdgeConstraint); 
      rmSetAreaLocPlayer(id, i);
      rmSetAreaMix(id, "patagonia_dirt"); // FROM PATAGONIA:
	  rmSetAreaTerrainType(id, "patagonia\ground_dirt1_pat"); // FROM PATAGONIA:
      rmSetAreaWarnFailure(id, false);
   }
      rmBuildAllAreas();
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.55);
/*================================================================================================================*/
// ************************************ DEFINE AND PLACE THE NATIVES TRIBES: ************************************ //
/*================================================================================================================*/
   int nativeChoice = rmRandInt(1,2);
   int villageAID = -1;
   int villageType = rmRandInt(1,3);

   if (nativeChoice == 1)
	villageAID = rmCreateGrouping("village A", "native aztec village "+villageType);
   else if (nativeChoice == 2)
	// villageAID = rmCreateGrouping("village A", "native comanche village "+villageType);
	   villageAID = rmCreateGrouping("village A", "native inca village "+villageType);
   // rmSetGroupingMinDistance(villageAID, 25.0);
   // rmSetGroupingMaxDistance(villageAID, 90.0);
      rmSetGroupingMinDistance(villageAID, 45.0);
      rmSetGroupingMaxDistance(villageAID, 90.0);
   rmAddGroupingToClass(villageAID, rmClassID("natives"));
   rmAddGroupingToClass(villageAID, rmClassID("importantItem"));
   rmAddGroupingConstraint(villageAID, avoidImpassableLand);
   rmAddGroupingConstraint(villageAID, avoidTradeRoute);
   rmAddGroupingConstraint(villageAID, avoidImportantItem);
   rmAddGroupingConstraint(villageAID, avoidNatives);

   for(i=1; <cNumberPlayers)
   {
	rmPlaceGroupingAtLoc(villageAID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
   }
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.60);
/*================================================================================================================*/
// ****************************************** PLACE STARTING UNITS ETC ****************************************** //
/*================================================================================================================*/
      for(i=1; <cNumberPlayers)
   {
	  rmPlaceObjectDefAtLoc(TCID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
	  rmPlaceObjectDefAtLoc(startingUnits, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
	  rmPlaceObjectDefAtLoc(playerSilverID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
	  rmPlaceObjectDefAtLoc(playerSilver2ID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
	  rmPlaceObjectDefAtLoc(StartBerriesID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
	  rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
	  rmPlaceObjectDefAtLoc(pronghornID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
   }
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.65);
/*================================================================================================================*/
// ********************************** DEFINE AND PLACE THE SMALL ROCK SPIRES: *********************************** //
/*================================================================================================================*/
      int failCount=0;
      int numTries=cNumberNonGaiaPlayers*5;    
      for(i=0; <numTries)
   {
	  int smallMesaID=rmCreateArea("small mesa"+i);
	  rmSetAreaSize(smallMesaID, rmAreaTilesToFraction(8), rmAreaTilesToFraction(20));  	  
	  rmSetAreaWarnFailure(smallMesaID, false);
	  rmSetAreaCliffType(smallMesaID, "Patagonia");
	  rmAddAreaToClass(smallMesaID, rmClassID("canyon"));	
	  rmSetAreaCliffEdge(smallMesaID, 1, 1.0, 0.1, 1.0, 0);
	  rmSetAreaCliffHeight(smallMesaID, rmRandInt(6,9), 1.0, 1.0);
	  rmSetAreaMinBlobs(smallMesaID, 1);
	  rmSetAreaMaxBlobs(smallMesaID, 2);
	  rmSetAreaMinBlobDistance(smallMesaID, 4.0);
	  rmSetAreaMaxBlobDistance(smallMesaID, 6.0);
	  rmSetAreaCoherence(smallMesaID, 0.3);
	  rmAddAreaConstraint(smallMesaID, shortAvoidCanyons);
	  rmAddAreaConstraint(smallMesaID, mediumPlayerConstraint); 
	  rmAddAreaConstraint(smallMesaID, avoidNatives);
	  rmAddAreaConstraint(smallMesaID, avoidWater);
	  rmAddAreaConstraint(smallMesaID, avoidImportantItem); 
	  rmAddAreaConstraint(smallMesaID, avoidTradeRouteSockets);
	  rmAddAreaConstraint(smallMesaID, avoidTradeRoute);
	  //rmAddAreaConstraint(smallMesaID, shortAvoidSilver);
	  rmAddAreaConstraint(smallMesaID, connectionConstraintLong);
	  rmAddAreaConstraint(smallMesaID, edgeConstraint);
	  if(rmBuildArea(smallMesaID)==false)
	{
	  // Stop trying once we fail 3 times in a row.
	  failCount++;
	  if(failCount==20)
	  break;
	}
	  else
	  failCount=0;
   }
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.70);
/*================================================================================================================*/
// ************************************** DEFINE AND PLACE THE FISHES: ****************************************** //
/*================================================================================================================*/
      // FISHES:
      int fishID=rmCreateObjectDef("fish");
      int fishVsFishID=rmCreateTypeDistanceConstraint("fish v fish", "fish", 26.0);
      int fishLand = rmCreateTerrainDistanceConstraint("fish land", "land", true, 7.0);
      // rmAddObjectDefItem(fishID, "FishBass", 1, 0.0);
         rmAddObjectDefItem(fishID, "FishBass", 3, 6.0);
      rmSetObjectDefMinDistance(fishID, 0.0);
      rmSetObjectDefMaxDistance(fishID, rmXFractionToMeters(0.5));
      rmAddObjectDefConstraint(fishID, fishVsFishID);
      rmAddObjectDefConstraint(fishID, fishLand);
      if (cNumberNonGaiaPlayers < 4)
      // rmPlaceObjectDefAtLoc(fishID, 0, 0.5, 0.5, rmRandInt(3,5));
	     rmPlaceObjectDefAtLoc(fishID, 0, 0.5, 0.5, rmRandInt(9,15));
      else
	  // rmPlaceObjectDefAtLoc(fishID, 0, 0.5, 0.5, rmRandInt(4,6));
	     rmPlaceObjectDefAtLoc(fishID, 0, 0.5, 0.5, rmRandInt(12,18));
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.75);
/*================================================================================================================*/
// **************************************** DEFINE AND PLACE THE FORESTS: *************************************** //
/*================================================================================================================*/
	  int forestTreeID = 0;
      numTries=7*cNumberNonGaiaPlayers;
      if (cNumberNonGaiaPlayers == 3)
      numTries=6*cNumberNonGaiaPlayers;
      if (cNumberNonGaiaPlayers > 3)
      numTries=5*cNumberNonGaiaPlayers;
      failCount=0;
   
       for (i=0; <numTries)
   {  
      int forest=rmCreateArea("forest "+i);
      rmSetAreaWarnFailure(forest, false);
      rmSetAreaSize(forest, rmAreaTilesToFraction(220), rmAreaTilesToFraction(400));
      rmSetAreaForestType(forest, "patagonia forest");
      rmSetAreaForestDensity(forest, 0.8);
      rmSetAreaForestClumpiness(forest, rmRandFloat(0.5,0.8));
      rmSetAreaForestUnderbrush(forest, 0.0);
      rmSetAreaMinBlobs(forest, 1);
      rmSetAreaMaxBlobs(forest, 3);
      rmSetAreaMinBlobDistance(forest, 16.0);
      rmSetAreaMaxBlobDistance(forest, 70.0);
      rmSetAreaCoherence(forest, 0.4);
      rmSetAreaSmoothDistance(forest, 0);
      rmAddAreaToClass(forest, rmClassID("classForest")); 
      rmAddAreaConstraint(forest, forestConstraint);
      rmAddAreaConstraint(forest, avoidNugget);
	  rmAddAreaConstraint(forest, avoidPronghorn);
	  rmAddAreaConstraint(forest, avoidAll);
	  rmAddAreaConstraint(forest, playerConstraint);
	  rmAddAreaConstraint(forest,  avoidWater);
      rmAddAreaConstraint(forest, edgeConstraint);
      rmAddAreaConstraint(forest, avoidFruits); 
      rmAddAreaConstraint(forest, avoidImpassableLand); 
      rmAddAreaConstraint(forest, avoidNatives);
      rmAddAreaConstraint(forest, avoidCoin);
      if(rmBuildArea(forest)==false)
      {
         // Stop trying once we fail 3 times in a row.
         failCount++;
         if(failCount==5)
            break;
      }
      else
         failCount=0; 
   }		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.80);
/*================================================================================================================*/
// ************************************ DEFINE AND PLACE THE SILVER MINES: ************************************** //
/*================================================================================================================*/
   // SILVER MINES - PLAYERS:
   int silverType = -1;
   silverType = rmRandInt(1,10);
   int playerGoldID=rmCreateObjectDef("player silver closer");
   rmAddObjectDefItem(playerGoldID, "minegold", 1, 0.0);
   rmAddObjectDefConstraint(playerGoldID, avoidCoin);
   rmAddObjectDefConstraint(playerGoldID, edgeConstraint);
   rmAddObjectDefConstraint(playerGoldID, coinAvoidCoin);
   rmAddObjectDefConstraint(playerGoldID, avoidImportantItem);
   rmAddObjectDefConstraint(playerGoldID, avoidAll);
   rmAddObjectDefConstraint(playerGoldID, playerConstraint);
   rmAddObjectDefConstraint(playerGoldID, avoidNugget);
   rmAddObjectDefConstraint(playerGoldID, avoidFruits);
   rmAddObjectDefConstraint(playerGoldID, avoidWater);
   rmSetObjectDefMinDistance(playerGoldID, 18.0);
   rmSetObjectDefMaxDistance(playerGoldID, 23.0);
   rmPlaceObjectDefPerPlayer(playerGoldID, false, 1);

   rmSetObjectDefMinDistance(playerGoldID, 50.0);
   rmSetObjectDefMaxDistance(playerGoldID, 60.0);
   rmPlaceObjectDefPerPlayer(playerGoldID, false, 1);

   silverType = rmRandInt(1,10);
   int GoldMediumID=rmCreateObjectDef("player silver med");
   rmAddObjectDefItem(GoldMediumID, "minegold", 1, 0.0);
   rmAddObjectDefConstraint(GoldMediumID, avoidCoin);
   rmAddObjectDefConstraint(GoldMediumID, edgeConstraint);
   rmAddObjectDefConstraint(GoldMediumID, coinAvoidCoin);
   rmAddObjectDefConstraint(GoldMediumID, avoidImportantItem);
   rmAddObjectDefConstraint(GoldMediumID, playerConstraint);
   rmAddObjectDefConstraint(GoldMediumID, avoidAll);
   rmAddObjectDefConstraint(GoldMediumID, avoidNugget);
   rmAddObjectDefConstraint(GoldMediumID, avoidFruits);
   rmAddObjectDefConstraint(GoldMediumID, avoidWater);
   rmSetObjectDefMinDistance(GoldMediumID, 85.0);
   rmSetObjectDefMaxDistance(GoldMediumID, 100.0);
   rmPlaceObjectDefPerPlayer(GoldMediumID, false, 1);	 
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.85);
/*================================================================================================================*/
// ******************************** DEFINING AND CREATING THE RANDOM NUGGETS: *********************************** //
/*================================================================================================================*/
   // RANDOM NUGGETS:
   int nuggetID= rmCreateObjectDef("nugget"); 
   rmAddObjectDefItem(nuggetID, "Nugget", 1, 0.0);
   rmAddObjectDefToClass(nuggetID, rmClassID("nuggets"));
   rmSetObjectDefMinDistance(nuggetID, 45.0);
   rmSetObjectDefMaxDistance(nuggetID, rmXFractionToMeters(0.35));
   rmAddObjectDefConstraint(nuggetID, avoidImpassableLand);
   rmAddObjectDefConstraint(nuggetID, avoidNugget);
   rmAddObjectDefConstraint(nuggetID, nuggetAvoidNugget);
   rmAddObjectDefConstraint(nuggetID, avoidStartingUnits);
   rmAddObjectDefConstraint(nuggetID, avoidNatives);
   rmAddObjectDefConstraint(nuggetID, avoidCoin);
   rmAddObjectDefConstraint(nuggetID, avoidAll);
   rmAddObjectDefConstraint(nuggetID, playerConstraint);
   //rmAddObjectDefConstraint(nuggetID, circleConstraint);
   rmAddObjectDefConstraint(nuggetID, avoidWater);

   for(i=1; <cNumberPlayers)
   {
      rmSetNuggetDifficulty(2, 2);
	rmPlaceObjectDefAtLoc(nuggetID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
      rmSetNuggetDifficulty(3, 3);
	rmPlaceObjectDefAtLoc(nuggetID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
   }
   rmSetObjectDefMinDistance(nuggetID, 85.0);
   for(i=1; <cNumberPlayers)
   {
      rmSetNuggetDifficulty(2, 2);
	rmPlaceObjectDefAtLoc(nuggetID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
      rmSetNuggetDifficulty(4, 4);
	rmPlaceObjectDefAtLoc(nuggetID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
   }
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.90);
/*================================================================================================================*/
// ************************************* DEFINE AND PLACE THE PRONGHORNS: *************************************** //
/*================================================================================================================*/
   // START AREA HUNTABLE:
   int pronghorn2Num = rmRandInt(4, 6);
   int Pronghorn2ID=rmCreateObjectDef("starting pronghorn 2");
   rmAddObjectDefItem(Pronghorn2ID, "pronghorn", pronghorn2Num, 4.0);
   //rmAddObjectDefToClass(Pronghorn2ID, rmClassID("huntableFood"));
   rmSetObjectDefMinDistance(Pronghorn2ID, 25);
   rmSetObjectDefMaxDistance(Pronghorn2ID, 35);
   //rmAddObjectDefConstraint(Pronghorn2ID, avoidStartResource);
   rmAddObjectDefConstraint(Pronghorn2ID, avoidImpassableLand);
   rmAddObjectDefConstraint(Pronghorn2ID, avoidAll);
   rmAddObjectDefConstraint(Pronghorn2ID, playerConstraint);
   rmAddObjectDefConstraint(Pronghorn2ID, avoidCoin);
   rmAddObjectDefConstraint(Pronghorn2ID, avoidNugget);
   rmAddObjectDefConstraint(Pronghorn2ID, avoidPronghorn);
   rmAddObjectDefConstraint(Pronghorn2ID, pronghornAvoidPronghorn);
   rmSetObjectDefCreateHerd(Pronghorn2ID, true);
   rmPlaceObjectDefPerPlayer(Pronghorn2ID, false, 1);

   // SECOND HUNTABLE:
   int pronghorn3Num = rmRandInt(4, 7);
   int Pronghorn3ID=rmCreateObjectDef("pronghorn 3");
   rmAddObjectDefItem(Pronghorn3ID, "pronghorn", pronghorn3Num, 4.0);
   //rmAddObjectDefToClass(Pronghorn3ID, rmClassID("huntableFood"));
   rmSetObjectDefMinDistance(Pronghorn3ID, 42.0);
   rmSetObjectDefMaxDistance(Pronghorn3ID, 65.0);
   //rmAddObjectDefConstraint(Pronghorn3ID, avoidStartResource);
   rmAddObjectDefConstraint(Pronghorn3ID, playerConstraint);
   rmAddObjectDefConstraint(Pronghorn3ID, avoidImpassableLand);
   rmAddObjectDefConstraint(Pronghorn3ID, avoidNatives);
   rmAddObjectDefConstraint(Pronghorn3ID, avoidCoin);
   rmAddObjectDefConstraint(Pronghorn3ID, avoidAll);
   rmAddObjectDefConstraint(Pronghorn3ID, avoidNugget);
   rmAddObjectDefConstraint(Pronghorn3ID, avoidPronghorn);
   rmAddObjectDefConstraint(Pronghorn3ID, pronghornAvoidPronghorn);
   rmSetObjectDefCreateHerd(Pronghorn3ID, true);
   
   if (cNumberNonGaiaPlayers < 3)
      rmPlaceObjectDefPerPlayer(Pronghorn3ID, false, 2);
   else
      rmPlaceObjectDefPerPlayer(Pronghorn3ID, false, 1);

   // additional second huntable for low player numbers
   if (cNumberNonGaiaPlayers < 4)
   {
      rmSetObjectDefMinDistance(Pronghorn3ID, rmXFractionToMeters(0.25));
      rmSetObjectDefMaxDistance(Pronghorn3ID, rmXFractionToMeters(0.35));
      rmPlaceObjectDefPerPlayer(Pronghorn3ID, false, 1);
   }
/*================================================================================================================*/
// *************************************** DEFINE AND PLACE THE SHEEPS: ***************************************** //
/*================================================================================================================*/
      int sheepID=rmCreateObjectDef("herdable animal");
      rmAddObjectDefItem(sheepID, "sheep", 2, 4.0);
      //rmAddObjectDefToClass(sheepID, rmClassID("herdableFood"));
      rmSetObjectDefMinDistance(sheepID, 35.0);
      rmSetObjectDefMaxDistance(sheepID, rmXFractionToMeters(0.3));
      rmAddObjectDefConstraint(sheepID, avoidSheep);
      rmAddObjectDefConstraint(sheepID, avoidAll);
	  rmAddObjectDefConstraint(sheepID, avoidNugget);
	  rmAddObjectDefConstraint(sheepID, avoidCoin);
	  rmAddObjectDefConstraint(sheepID, avoidFruits);
      rmAddObjectDefConstraint(sheepID, playerConstraint);
      rmAddObjectDefConstraint(sheepID, edgeConstraint);
      rmAddObjectDefConstraint(sheepID, avoidImpassableLand);
      if (rmRandInt(1,2) == 1)
         rmPlaceObjectDefAtLoc(sheepID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*2);
      else 
         rmPlaceObjectDefAtLoc(sheepID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*3); 

      rmSetObjectDefMaxDistance(sheepID, rmXFractionToMeters(0.45));
      rmPlaceObjectDefAtLoc(sheepID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*3); 
/*================================================================================================================*/		
// ********************************** DEFINE AND PLACE THE BERRY BUSHES: **************************************** //
/*================================================================================================================*/
      int RandomBerriesID=rmCreateObjectDef("Random Berries");
      rmAddObjectDefItem(RandomBerriesID, "berrybush", rmRandInt(3,5), 6.0);
      rmSetObjectDefMinDistance(RandomBerriesID, 0.0);
      rmSetObjectDefMaxDistance(RandomBerriesID, rmXFractionToMeters(0.5));
	  //rmAddObjectDefConstraint(RandomBerriesID, avoidDeer);
      rmAddObjectDefConstraint(RandomBerriesID, avoidSheep);
	  rmAddObjectDefConstraint(RandomBerriesID, avoidAll);
	  rmAddObjectDefConstraint(RandomBerriesID, avoidFruits);
	  rmAddObjectDefConstraint(RandomBerriesID, fruitsAvoidFruits);
	  rmAddObjectDefConstraint(RandomBerriesID, edgeConstraint);
	  rmAddObjectDefConstraint(RandomBerriesID, avoidCoin);
	  rmAddObjectDefConstraint(RandomBerriesID, avoidNugget);
	  rmAddObjectDefConstraint(RandomBerriesID, playerConstraint);
	  rmAddObjectDefConstraint(RandomBerriesID, avoidNatives);
      rmAddObjectDefConstraint(RandomBerriesID, avoidImpassableLand);
	  rmPlaceObjectDefAtLoc(RandomBerriesID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*6);    
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.95);
/*================================================================================================================*/
// ************************************ DEFINE AND PLACE THE RANDOM TREES: ************************************** //
/*================================================================================================================*/
      // DEFINE AND PLACE THE RANDOM TREES:
      int StragglerTreeID=rmCreateObjectDef("stragglers");
      rmAddObjectDefItem(StragglerTreeID, "TreePatagoniaDirt", 1, 0.0);
      rmAddObjectDefConstraint(StragglerTreeID, avoidAll);
	  rmAddObjectDefConstraint(StragglerTreeID, avoidNugget);
      rmAddObjectDefConstraint(StragglerTreeID, avoidStartingUnits);
      rmAddObjectDefConstraint(StragglerTreeID, playerConstraint);
      rmAddObjectDefConstraint(StragglerTreeID, edgeConstraint);
      rmAddObjectDefConstraint(StragglerTreeID, avoidNatives);
      rmAddObjectDefConstraint(StragglerTreeID, avoidWater);
	  rmAddObjectDefConstraint(StragglerTreeID, avoidCoin);
      rmSetObjectDefMinDistance(StragglerTreeID, 10.0);
      rmSetObjectDefMaxDistance(StragglerTreeID, rmXFractionToMeters(0.5));
      for(i=0; <cNumberNonGaiaPlayers*25)
      rmPlaceObjectDefAtLoc(StragglerTreeID, 0, 0.5, 0.5);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",1.00);
/*================================================================================================================*/
}  
/*================================================================================================================*/
// *************************************** THIS IS THE END OF THE MAP: ****************************************** //
/*================================================================================================================*/

